package no.valg.valgnatt.database.forberedvalg.bean;

import lombok.Getter;
import lombok.Setter;
import no.valg.valgnatt.database.forberedvalg.geografi.Krets;
import no.valg.valgnatt.database.forberedvalg.geografi.Parti;

import java.util.List;

@Getter
@Setter
public class BeanHistorikkStemmetallMod extends Bean {

    private int svts;
    private int nsvts;
    private int sfhs;
    private int nsfhs;

    @Override
    public String getKey() {
        return makeKey(getValgtype(), getKommnr(), getKretsnr(), getPartikode());
    }

    public static String makeKey(String valgtype, String kommnr, String kretsnr, String partikode) {
        return valgtype + kommnr + kretsnr + partikode;
    }

    public void setStemmerFraNSV(List<Krets> kretserNSV, Parti parti) {
        for (Krets kretsNSV : kretserNSV) {
            if (kretsNSV.getParti(parti.getPartikode()) != null) {
                nsfhs += kretsNSV.getParti(parti.getPartikode()).getFhs();
                nsvts += kretsNSV.getParti(parti.getPartikode()).getVts();
            }
        }
    }

    public void setStemmerFraSV(List<Krets> kretserSV, Parti parti) {
        for (Krets kretsSV : kretserSV) {
            if (kretsSV.getParti(parti.getPartikode()) != null) {
                sfhs += kretsSV.getParti(parti.getPartikode()).getFhs();
                svts += kretsSV.getParti(parti.getPartikode()).getVts();
            }
        }
    }
    
}
